#!/bin/sh
#Editeur.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}

############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  :  can2svg.tcl - inspir des travaux de Mats Bengtsson
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version
# @author     David Lucardi
# @project
# @copyright  David Lucardi 08/05/2004
#
#
#########################################################################


namespace eval ::can2svg:: {
#######################################################################"
proc substexte {texte} {
return [string map { "&#x00FB;"  "&#x00E0;"  "&#x00F9;"  "&#x00E8;"  "&#x00E9;"  "&#x00EA;"  "&#x00EB;"  "&#x00EE;"  "&#x00E7;"  "&#x00E2;"  "&#x00EF;"  "&#x00F4;"  "&#x00F6;"  "&#x00FC;"} $texte]
}

proc createimage {c fichier x y zoom1 zoom2 identif} {
global xml Home
image create photo bimage -file [file join $Home images $fichier]
set width [expr [image width bimage]*$zoom1] 
set height [expr [image height bimage]*$zoom2]
set x0 [expr $x - $width/2]
set y0 [expr $y - $height/2]
lappend  xml $identif
lappend xml "<image x=\'$x0\' y=\'$y0\' width=\'$width\' height=\'$height\' xlink:href='./images/$fichier'/>"

}

########################################################################"
proc createbouton2 {c fichier x y zoom1 zoom2 identif texte police coul} {
   global xml Home
   image create photo bimage -file [file join $Home images $fichier]
   set width [expr [image width bimage]*$zoom1] 
   set height [expr [image height bimage]*$zoom2]
   set x0 [expr $x - $width/2]
   set y0 [expr $y - $height/2]
lappend  xml back$identif
lappend xml "<image x=\'$x0\' y=\'$y0\' width=\'$width\' height=\'$height\' xlink:href='./images/$fichier'/>"

#set textWidth [expr [font measure {Helvetica 16 bold} $texte] - 2*[string length $texte]]

set taille [expr int((12*4)/3) -1]
set fontm "Helvetica $taille bold"
set textWidth [font measure $fontm $texte]
set ascent [font metrics $fontm -ascent]
set lineSpace [font metrics $fontm -linespace]
set x [expr $x - $textWidth/2.0]
set y [expr $y - $lineSpace/2.0 + $ascent]
lappend xml $identif
lappend xml "<text x=\'$x\' y=\'$y\' style='font-family: Helvetica; font-size : $taille;font-weight : bold;'>[substexte $texte]</text>"
}
#####################################################################"
proc createtexte {c x y texte couleur largeur hauteur fillcouleur police taillepol trait identif sep} {
global taillefont xml plateforme
set taille [lindex $taillefont $taillepol]

set texte [string map {"\\n" " "} $texte]
set lineSpace [font metrics "$police $taille" -linespace]
set ascent [font metrics "$police $taille" -ascent]
set indexv 0
set indext 0
set maxlength 0
set data ""
set delta 0

set x [expr $x - $largeur/2.0]
set y [expr $y]
set yt [expr $y + $ascent/2]

foreach item $sep {
set data "$data <tspan x=\'$x\' dy=\'$lineSpace\'>[substexte [string trimleft [string range $texte $indext $item]]]</tspan>"
set indext [expr $item +1]
}
switch $plateforme {
	windows {
	set taille [expr int(([lindex $taillefont $taillepol]*4)/3) -1]
	if {$taillepol <=1} {set delta 2}
	}
	unix {
	if {$police != "Arial"} {
	if {$taillepol >2}  {set delta -1}
	if {$taillepol >5}  {set delta -3}
	}
	}
}

if {$trait != ""} {
if {$couleur == ""} {set couleur "none"}
lappend xml back$identif
lappend xml "<rect x=\'[expr $x -2]\' y=\'[expr $yt -2]\' width =\'[expr $largeur +6]\' height=\'$hauteur\' style='stroke : $trait; fill : $couleur;'/>"
}
set taille [expr $taille + $delta]
lappend xml $identif
lappend xml "<text x=\'$x\' y=\'$y\' style='font-family: $police; font-size : $taille; fill : $fillcouleur'>$data</text>"

#set idtmp1 [$c create text $x $y -text [join $texte] -width $largeur -anchor n -font "$police [lindex $taillefont $taillepol]" -justify left -fill $fillcouleur -tags "drag $id typetext" ]

}

#################################################################"
proc createpolygon {c fichier arrcoul linecoul smoth identif} {

global xml


if {$smoth==1} {
set x0 [expr ([lindex $fichier end-1] + [lindex $fichier 0])/2.0]
set y0 [expr ([lindex $fichier end] + [lindex $fichier 1])/2.0]
set data "M $x0 $y0 Q"
set i 2
foreach {x y} [lrange $fichier 0 end-2] {
set x1 [expr ($x + [lindex $fichier $i])/2.0]
incr i
set y1 [expr ($y + [lindex $fichier $i])/2.0]
incr i
append data " $x $y $x1 $y1"
set root "path d="			    
}
append data " [lrange $fichier end-1 end] $x0 $y0"
} else {
set data $fichier
set root "polygon points="			    
} 

lappend xml $identif
lappend xml "<$root\'$data\' style='fill-rule : evenodd; stroke: $linecoul; fill : $arrcoul;'/>"

}
#################################################################
proc createbouton1 {c fichier arrfill outcoul tag identif} {
global xml xindexpage

set data $fichier
set root "polygon points="			    
set ext .svg
switch $tag {
	pageprec {set prefix "<a xlink:href='page[expr $xindexpage -1]$ext'>" }
	pagesuiv {set prefix "<a xlink:href='page[expr $xindexpage +1]$ext'>" }
	sommaire {set prefix "<a xlink:href='page1$ext'>" }

}
		
lappend xml $identif
lappend xml "$prefix<$root \'$data\' style='fill-rule : evenodd; stroke: $outcoul; fill : $arrfill;'/></a>"

#$c create polygon $it -fill $arrfill -tags "drag $id $tag typebouton1" -outline $outcoul

}


####################################################################"

}


    

